/*******************************************************************************
* File Name: Clk25KHz_Gen.h
* Version 2.10
*
* Description:
*  This file provides constants and parameter values for the Clk25KHz_Gen
*  component.
*
* Note:
*  None
*
********************************************************************************
* Copyright 2013-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_TCPWM_Clk25KHz_Gen_H)
#define CY_TCPWM_Clk25KHz_Gen_H


#include "CyLib.h"
#include "cytypes.h"
#include "cyfitter.h"


/*******************************************************************************
* Internal Type defines
*******************************************************************************/

/* Structure to save state before go to sleep */
typedef struct
{
    uint8  enableState;
} Clk25KHz_Gen_BACKUP_STRUCT;


/*******************************************************************************
* Variables
*******************************************************************************/
extern uint8  Clk25KHz_Gen_initVar;


/***************************************
*   Conditional Compilation Parameters
****************************************/

#define Clk25KHz_Gen_CY_TCPWM_V2                    (CYIPBLOCK_m0s8tcpwm_VERSION == 2u)
#define Clk25KHz_Gen_CY_TCPWM_4000                  (CY_PSOC4_4000)

/* TCPWM Configuration */
#define Clk25KHz_Gen_CONFIG                         (7lu)

/* Quad Mode */
/* Parameters */
#define Clk25KHz_Gen_QUAD_ENCODING_MODES            (0lu)
#define Clk25KHz_Gen_QUAD_AUTO_START                (1lu)

/* Signal modes */
#define Clk25KHz_Gen_QUAD_INDEX_SIGNAL_MODE         (0lu)
#define Clk25KHz_Gen_QUAD_PHIA_SIGNAL_MODE          (3lu)
#define Clk25KHz_Gen_QUAD_PHIB_SIGNAL_MODE          (3lu)
#define Clk25KHz_Gen_QUAD_STOP_SIGNAL_MODE          (0lu)

/* Signal present */
#define Clk25KHz_Gen_QUAD_INDEX_SIGNAL_PRESENT      (0lu)
#define Clk25KHz_Gen_QUAD_STOP_SIGNAL_PRESENT       (0lu)

/* Interrupt Mask */
#define Clk25KHz_Gen_QUAD_INTERRUPT_MASK            (1lu)

/* Timer/Counter Mode */
/* Parameters */
#define Clk25KHz_Gen_TC_RUN_MODE                    (0lu)
#define Clk25KHz_Gen_TC_COUNTER_MODE                (0lu)
#define Clk25KHz_Gen_TC_COMP_CAP_MODE               (2lu)
#define Clk25KHz_Gen_TC_PRESCALER                   (0lu)

/* Signal modes */
#define Clk25KHz_Gen_TC_RELOAD_SIGNAL_MODE          (0lu)
#define Clk25KHz_Gen_TC_COUNT_SIGNAL_MODE           (3lu)
#define Clk25KHz_Gen_TC_START_SIGNAL_MODE           (0lu)
#define Clk25KHz_Gen_TC_STOP_SIGNAL_MODE            (0lu)
#define Clk25KHz_Gen_TC_CAPTURE_SIGNAL_MODE         (0lu)

/* Signal present */
#define Clk25KHz_Gen_TC_RELOAD_SIGNAL_PRESENT       (0lu)
#define Clk25KHz_Gen_TC_COUNT_SIGNAL_PRESENT        (0lu)
#define Clk25KHz_Gen_TC_START_SIGNAL_PRESENT        (0lu)
#define Clk25KHz_Gen_TC_STOP_SIGNAL_PRESENT         (0lu)
#define Clk25KHz_Gen_TC_CAPTURE_SIGNAL_PRESENT      (0lu)

/* Interrupt Mask */
#define Clk25KHz_Gen_TC_INTERRUPT_MASK              (1lu)

/* PWM Mode */
/* Parameters */
#define Clk25KHz_Gen_PWM_KILL_EVENT                 (0lu)
#define Clk25KHz_Gen_PWM_STOP_EVENT                 (0lu)
#define Clk25KHz_Gen_PWM_MODE                       (4lu)
#define Clk25KHz_Gen_PWM_OUT_N_INVERT               (0lu)
#define Clk25KHz_Gen_PWM_OUT_INVERT                 (0lu)
#define Clk25KHz_Gen_PWM_ALIGN                      (0lu)
#define Clk25KHz_Gen_PWM_RUN_MODE                   (0lu)
#define Clk25KHz_Gen_PWM_DEAD_TIME_CYCLE            (0lu)
#define Clk25KHz_Gen_PWM_PRESCALER                  (0lu)

/* Signal modes */
#define Clk25KHz_Gen_PWM_RELOAD_SIGNAL_MODE         (0lu)
#define Clk25KHz_Gen_PWM_COUNT_SIGNAL_MODE          (3lu)
#define Clk25KHz_Gen_PWM_START_SIGNAL_MODE          (0lu)
#define Clk25KHz_Gen_PWM_STOP_SIGNAL_MODE           (0lu)
#define Clk25KHz_Gen_PWM_SWITCH_SIGNAL_MODE         (0lu)

/* Signal present */
#define Clk25KHz_Gen_PWM_RELOAD_SIGNAL_PRESENT      (0lu)
#define Clk25KHz_Gen_PWM_COUNT_SIGNAL_PRESENT       (0lu)
#define Clk25KHz_Gen_PWM_START_SIGNAL_PRESENT       (0lu)
#define Clk25KHz_Gen_PWM_STOP_SIGNAL_PRESENT        (0lu)
#define Clk25KHz_Gen_PWM_SWITCH_SIGNAL_PRESENT      (0lu)

/* Interrupt Mask */
#define Clk25KHz_Gen_PWM_INTERRUPT_MASK             (1lu)


/***************************************
*    Initial Parameter Constants
***************************************/

/* Timer/Counter Mode */
#define Clk25KHz_Gen_TC_PERIOD_VALUE                (65535lu)
#define Clk25KHz_Gen_TC_COMPARE_VALUE               (65535lu)
#define Clk25KHz_Gen_TC_COMPARE_BUF_VALUE           (65535lu)
#define Clk25KHz_Gen_TC_COMPARE_SWAP                (0lu)

/* PWM Mode */
#define Clk25KHz_Gen_PWM_PERIOD_VALUE               (10000lu)
#define Clk25KHz_Gen_PWM_PERIOD_BUF_VALUE           (65535lu)
#define Clk25KHz_Gen_PWM_PERIOD_SWAP                (0lu)
#define Clk25KHz_Gen_PWM_COMPARE_VALUE              (5000lu)
#define Clk25KHz_Gen_PWM_COMPARE_BUF_VALUE          (65535lu)
#define Clk25KHz_Gen_PWM_COMPARE_SWAP               (0lu)


/***************************************
*    Enumerated Types and Parameters
***************************************/

#define Clk25KHz_Gen__LEFT 0
#define Clk25KHz_Gen__RIGHT 1
#define Clk25KHz_Gen__CENTER 2
#define Clk25KHz_Gen__ASYMMETRIC 3

#define Clk25KHz_Gen__X1 0
#define Clk25KHz_Gen__X2 1
#define Clk25KHz_Gen__X4 2

#define Clk25KHz_Gen__PWM 4
#define Clk25KHz_Gen__PWM_DT 5
#define Clk25KHz_Gen__PWM_PR 6

#define Clk25KHz_Gen__INVERSE 1
#define Clk25KHz_Gen__DIRECT 0

#define Clk25KHz_Gen__CAPTURE 2
#define Clk25KHz_Gen__COMPARE 0

#define Clk25KHz_Gen__TRIG_LEVEL 3
#define Clk25KHz_Gen__TRIG_RISING 0
#define Clk25KHz_Gen__TRIG_FALLING 1
#define Clk25KHz_Gen__TRIG_BOTH 2

#define Clk25KHz_Gen__INTR_MASK_TC 1
#define Clk25KHz_Gen__INTR_MASK_CC_MATCH 2
#define Clk25KHz_Gen__INTR_MASK_NONE 0
#define Clk25KHz_Gen__INTR_MASK_TC_CC 3

#define Clk25KHz_Gen__UNCONFIG 8
#define Clk25KHz_Gen__TIMER 1
#define Clk25KHz_Gen__QUAD 3
#define Clk25KHz_Gen__PWM_SEL 7

#define Clk25KHz_Gen__COUNT_UP 0
#define Clk25KHz_Gen__COUNT_DOWN 1
#define Clk25KHz_Gen__COUNT_UPDOWN0 2
#define Clk25KHz_Gen__COUNT_UPDOWN1 3


/* Prescaler */
#define Clk25KHz_Gen_PRESCALE_DIVBY1                ((uint32)(0u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY2                ((uint32)(1u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY4                ((uint32)(2u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY8                ((uint32)(3u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY16               ((uint32)(4u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY32               ((uint32)(5u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY64               ((uint32)(6u << Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_PRESCALE_DIVBY128              ((uint32)(7u << Clk25KHz_Gen_PRESCALER_SHIFT))

/* TCPWM set modes */
#define Clk25KHz_Gen_MODE_TIMER_COMPARE             ((uint32)(Clk25KHz_Gen__COMPARE         <<  \
                                                                  Clk25KHz_Gen_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_TIMER_CAPTURE             ((uint32)(Clk25KHz_Gen__CAPTURE         <<  \
                                                                  Clk25KHz_Gen_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_QUAD                      ((uint32)(Clk25KHz_Gen__QUAD            <<  \
                                                                  Clk25KHz_Gen_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_PWM                       ((uint32)(Clk25KHz_Gen__PWM             <<  \
                                                                  Clk25KHz_Gen_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_PWM_DT                    ((uint32)(Clk25KHz_Gen__PWM_DT          <<  \
                                                                  Clk25KHz_Gen_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_PWM_PR                    ((uint32)(Clk25KHz_Gen__PWM_PR          <<  \
                                                                  Clk25KHz_Gen_MODE_SHIFT))

/* Quad Modes */
#define Clk25KHz_Gen_MODE_X1                        ((uint32)(Clk25KHz_Gen__X1              <<  \
                                                                  Clk25KHz_Gen_QUAD_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_X2                        ((uint32)(Clk25KHz_Gen__X2              <<  \
                                                                  Clk25KHz_Gen_QUAD_MODE_SHIFT))
#define Clk25KHz_Gen_MODE_X4                        ((uint32)(Clk25KHz_Gen__X4              <<  \
                                                                  Clk25KHz_Gen_QUAD_MODE_SHIFT))

/* Counter modes */
#define Clk25KHz_Gen_COUNT_UP                       ((uint32)(Clk25KHz_Gen__COUNT_UP        <<  \
                                                                  Clk25KHz_Gen_UPDOWN_SHIFT))
#define Clk25KHz_Gen_COUNT_DOWN                     ((uint32)(Clk25KHz_Gen__COUNT_DOWN      <<  \
                                                                  Clk25KHz_Gen_UPDOWN_SHIFT))
#define Clk25KHz_Gen_COUNT_UPDOWN0                  ((uint32)(Clk25KHz_Gen__COUNT_UPDOWN0   <<  \
                                                                  Clk25KHz_Gen_UPDOWN_SHIFT))
#define Clk25KHz_Gen_COUNT_UPDOWN1                  ((uint32)(Clk25KHz_Gen__COUNT_UPDOWN1   <<  \
                                                                  Clk25KHz_Gen_UPDOWN_SHIFT))

/* PWM output invert */
#define Clk25KHz_Gen_INVERT_LINE                    ((uint32)(Clk25KHz_Gen__INVERSE         <<  \
                                                                  Clk25KHz_Gen_INV_OUT_SHIFT))
#define Clk25KHz_Gen_INVERT_LINE_N                  ((uint32)(Clk25KHz_Gen__INVERSE         <<  \
                                                                  Clk25KHz_Gen_INV_COMPL_OUT_SHIFT))

/* Trigger modes */
#define Clk25KHz_Gen_TRIG_RISING                    ((uint32)Clk25KHz_Gen__TRIG_RISING)
#define Clk25KHz_Gen_TRIG_FALLING                   ((uint32)Clk25KHz_Gen__TRIG_FALLING)
#define Clk25KHz_Gen_TRIG_BOTH                      ((uint32)Clk25KHz_Gen__TRIG_BOTH)
#define Clk25KHz_Gen_TRIG_LEVEL                     ((uint32)Clk25KHz_Gen__TRIG_LEVEL)

/* Interrupt mask */
#define Clk25KHz_Gen_INTR_MASK_TC                   ((uint32)Clk25KHz_Gen__INTR_MASK_TC)
#define Clk25KHz_Gen_INTR_MASK_CC_MATCH             ((uint32)Clk25KHz_Gen__INTR_MASK_CC_MATCH)

/* PWM Output Controls */
#define Clk25KHz_Gen_CC_MATCH_SET                   (0x00u)
#define Clk25KHz_Gen_CC_MATCH_CLEAR                 (0x01u)
#define Clk25KHz_Gen_CC_MATCH_INVERT                (0x02u)
#define Clk25KHz_Gen_CC_MATCH_NO_CHANGE             (0x03u)
#define Clk25KHz_Gen_OVERLOW_SET                    (0x00u)
#define Clk25KHz_Gen_OVERLOW_CLEAR                  (0x04u)
#define Clk25KHz_Gen_OVERLOW_INVERT                 (0x08u)
#define Clk25KHz_Gen_OVERLOW_NO_CHANGE              (0x0Cu)
#define Clk25KHz_Gen_UNDERFLOW_SET                  (0x00u)
#define Clk25KHz_Gen_UNDERFLOW_CLEAR                (0x10u)
#define Clk25KHz_Gen_UNDERFLOW_INVERT               (0x20u)
#define Clk25KHz_Gen_UNDERFLOW_NO_CHANGE            (0x30u)

/* PWM Align */
#define Clk25KHz_Gen_PWM_MODE_LEFT                  (Clk25KHz_Gen_CC_MATCH_CLEAR        |   \
                                                         Clk25KHz_Gen_OVERLOW_SET           |   \
                                                         Clk25KHz_Gen_UNDERFLOW_NO_CHANGE)
#define Clk25KHz_Gen_PWM_MODE_RIGHT                 (Clk25KHz_Gen_CC_MATCH_SET          |   \
                                                         Clk25KHz_Gen_OVERLOW_NO_CHANGE     |   \
                                                         Clk25KHz_Gen_UNDERFLOW_CLEAR)
#define Clk25KHz_Gen_PWM_MODE_ASYM                  (Clk25KHz_Gen_CC_MATCH_INVERT       |   \
                                                         Clk25KHz_Gen_OVERLOW_SET           |   \
                                                         Clk25KHz_Gen_UNDERFLOW_CLEAR)

#if (Clk25KHz_Gen_CY_TCPWM_V2)
    #if(Clk25KHz_Gen_CY_TCPWM_4000)
        #define Clk25KHz_Gen_PWM_MODE_CENTER                (Clk25KHz_Gen_CC_MATCH_INVERT       |   \
                                                                 Clk25KHz_Gen_OVERLOW_NO_CHANGE     |   \
                                                                 Clk25KHz_Gen_UNDERFLOW_CLEAR)
    #else
        #define Clk25KHz_Gen_PWM_MODE_CENTER                (Clk25KHz_Gen_CC_MATCH_INVERT       |   \
                                                                 Clk25KHz_Gen_OVERLOW_SET           |   \
                                                                 Clk25KHz_Gen_UNDERFLOW_CLEAR)
    #endif /* (Clk25KHz_Gen_CY_TCPWM_4000) */
#else
    #define Clk25KHz_Gen_PWM_MODE_CENTER                (Clk25KHz_Gen_CC_MATCH_INVERT       |   \
                                                             Clk25KHz_Gen_OVERLOW_NO_CHANGE     |   \
                                                             Clk25KHz_Gen_UNDERFLOW_CLEAR)
#endif /* (Clk25KHz_Gen_CY_TCPWM_NEW) */

/* Command operations without condition */
#define Clk25KHz_Gen_CMD_CAPTURE                    (0u)
#define Clk25KHz_Gen_CMD_RELOAD                     (8u)
#define Clk25KHz_Gen_CMD_STOP                       (16u)
#define Clk25KHz_Gen_CMD_START                      (24u)

/* Status */
#define Clk25KHz_Gen_STATUS_DOWN                    (1u)
#define Clk25KHz_Gen_STATUS_RUNNING                 (2u)


/***************************************
*        Function Prototypes
****************************************/

void   Clk25KHz_Gen_Init(void);
void   Clk25KHz_Gen_Enable(void);
void   Clk25KHz_Gen_Start(void);
void   Clk25KHz_Gen_Stop(void);

void   Clk25KHz_Gen_SetMode(uint32 mode);
void   Clk25KHz_Gen_SetCounterMode(uint32 counterMode);
void   Clk25KHz_Gen_SetPWMMode(uint32 modeMask);
void   Clk25KHz_Gen_SetQDMode(uint32 qdMode);

void   Clk25KHz_Gen_SetPrescaler(uint32 prescaler);
void   Clk25KHz_Gen_TriggerCommand(uint32 mask, uint32 command);
void   Clk25KHz_Gen_SetOneShot(uint32 oneShotEnable);
uint32 Clk25KHz_Gen_ReadStatus(void);

void   Clk25KHz_Gen_SetPWMSyncKill(uint32 syncKillEnable);
void   Clk25KHz_Gen_SetPWMStopOnKill(uint32 stopOnKillEnable);
void   Clk25KHz_Gen_SetPWMDeadTime(uint32 deadTime);
void   Clk25KHz_Gen_SetPWMInvert(uint32 mask);

void   Clk25KHz_Gen_SetInterruptMode(uint32 interruptMask);
uint32 Clk25KHz_Gen_GetInterruptSourceMasked(void);
uint32 Clk25KHz_Gen_GetInterruptSource(void);
void   Clk25KHz_Gen_ClearInterrupt(uint32 interruptMask);
void   Clk25KHz_Gen_SetInterrupt(uint32 interruptMask);

void   Clk25KHz_Gen_WriteCounter(uint32 count);
uint32 Clk25KHz_Gen_ReadCounter(void);

uint32 Clk25KHz_Gen_ReadCapture(void);
uint32 Clk25KHz_Gen_ReadCaptureBuf(void);

void   Clk25KHz_Gen_WritePeriod(uint32 period);
uint32 Clk25KHz_Gen_ReadPeriod(void);
void   Clk25KHz_Gen_WritePeriodBuf(uint32 periodBuf);
uint32 Clk25KHz_Gen_ReadPeriodBuf(void);

void   Clk25KHz_Gen_WriteCompare(uint32 compare);
uint32 Clk25KHz_Gen_ReadCompare(void);
void   Clk25KHz_Gen_WriteCompareBuf(uint32 compareBuf);
uint32 Clk25KHz_Gen_ReadCompareBuf(void);

void   Clk25KHz_Gen_SetPeriodSwap(uint32 swapEnable);
void   Clk25KHz_Gen_SetCompareSwap(uint32 swapEnable);

void   Clk25KHz_Gen_SetCaptureMode(uint32 triggerMode);
void   Clk25KHz_Gen_SetReloadMode(uint32 triggerMode);
void   Clk25KHz_Gen_SetStartMode(uint32 triggerMode);
void   Clk25KHz_Gen_SetStopMode(uint32 triggerMode);
void   Clk25KHz_Gen_SetCountMode(uint32 triggerMode);

void   Clk25KHz_Gen_SaveConfig(void);
void   Clk25KHz_Gen_RestoreConfig(void);
void   Clk25KHz_Gen_Sleep(void);
void   Clk25KHz_Gen_Wakeup(void);


/***************************************
*             Registers
***************************************/

#define Clk25KHz_Gen_BLOCK_CONTROL_REG              (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_CTRL )
#define Clk25KHz_Gen_BLOCK_CONTROL_PTR              ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_CTRL )
#define Clk25KHz_Gen_COMMAND_REG                    (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_CMD )
#define Clk25KHz_Gen_COMMAND_PTR                    ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_CMD )
#define Clk25KHz_Gen_INTRRUPT_CAUSE_REG             (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_INTR_CAUSE )
#define Clk25KHz_Gen_INTRRUPT_CAUSE_PTR             ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_INTR_CAUSE )
#define Clk25KHz_Gen_CONTROL_REG                    (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__CTRL )
#define Clk25KHz_Gen_CONTROL_PTR                    ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__CTRL )
#define Clk25KHz_Gen_STATUS_REG                     (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__STATUS )
#define Clk25KHz_Gen_STATUS_PTR                     ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__STATUS )
#define Clk25KHz_Gen_COUNTER_REG                    (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__COUNTER )
#define Clk25KHz_Gen_COUNTER_PTR                    ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__COUNTER )
#define Clk25KHz_Gen_COMP_CAP_REG                   (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__CC )
#define Clk25KHz_Gen_COMP_CAP_PTR                   ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__CC )
#define Clk25KHz_Gen_COMP_CAP_BUF_REG               (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__CC_BUFF )
#define Clk25KHz_Gen_COMP_CAP_BUF_PTR               ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__CC_BUFF )
#define Clk25KHz_Gen_PERIOD_REG                     (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__PERIOD )
#define Clk25KHz_Gen_PERIOD_PTR                     ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__PERIOD )
#define Clk25KHz_Gen_PERIOD_BUF_REG                 (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__PERIOD_BUFF )
#define Clk25KHz_Gen_PERIOD_BUF_PTR                 ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__PERIOD_BUFF )
#define Clk25KHz_Gen_TRIG_CONTROL0_REG              (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TR_CTRL0 )
#define Clk25KHz_Gen_TRIG_CONTROL0_PTR              ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TR_CTRL0 )
#define Clk25KHz_Gen_TRIG_CONTROL1_REG              (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TR_CTRL1 )
#define Clk25KHz_Gen_TRIG_CONTROL1_PTR              ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TR_CTRL1 )
#define Clk25KHz_Gen_TRIG_CONTROL2_REG              (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TR_CTRL2 )
#define Clk25KHz_Gen_TRIG_CONTROL2_PTR              ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__TR_CTRL2 )
#define Clk25KHz_Gen_INTERRUPT_REQ_REG              (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR )
#define Clk25KHz_Gen_INTERRUPT_REQ_PTR              ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR )
#define Clk25KHz_Gen_INTERRUPT_SET_REG              (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR_SET )
#define Clk25KHz_Gen_INTERRUPT_SET_PTR              ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR_SET )
#define Clk25KHz_Gen_INTERRUPT_MASK_REG             (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR_MASK )
#define Clk25KHz_Gen_INTERRUPT_MASK_PTR             ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR_MASK )
#define Clk25KHz_Gen_INTERRUPT_MASKED_REG           (*(reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR_MASKED )
#define Clk25KHz_Gen_INTERRUPT_MASKED_PTR           ( (reg32 *) Clk25KHz_Gen_cy_m0s8_tcpwm_1__INTR_MASKED )


/***************************************
*       Registers Constants
***************************************/

/* Mask */
#define Clk25KHz_Gen_MASK                           ((uint32)Clk25KHz_Gen_cy_m0s8_tcpwm_1__TCPWM_CTRL_MASK)

/* Shift constants for control register */
#define Clk25KHz_Gen_RELOAD_CC_SHIFT                (0u)
#define Clk25KHz_Gen_RELOAD_PERIOD_SHIFT            (1u)
#define Clk25KHz_Gen_PWM_SYNC_KILL_SHIFT            (2u)
#define Clk25KHz_Gen_PWM_STOP_KILL_SHIFT            (3u)
#define Clk25KHz_Gen_PRESCALER_SHIFT                (8u)
#define Clk25KHz_Gen_UPDOWN_SHIFT                   (16u)
#define Clk25KHz_Gen_ONESHOT_SHIFT                  (18u)
#define Clk25KHz_Gen_QUAD_MODE_SHIFT                (20u)
#define Clk25KHz_Gen_INV_OUT_SHIFT                  (20u)
#define Clk25KHz_Gen_INV_COMPL_OUT_SHIFT            (21u)
#define Clk25KHz_Gen_MODE_SHIFT                     (24u)

/* Mask constants for control register */
#define Clk25KHz_Gen_RELOAD_CC_MASK                 ((uint32)(Clk25KHz_Gen_1BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_RELOAD_CC_SHIFT))
#define Clk25KHz_Gen_RELOAD_PERIOD_MASK             ((uint32)(Clk25KHz_Gen_1BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_RELOAD_PERIOD_SHIFT))
#define Clk25KHz_Gen_PWM_SYNC_KILL_MASK             ((uint32)(Clk25KHz_Gen_1BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_PWM_SYNC_KILL_SHIFT))
#define Clk25KHz_Gen_PWM_STOP_KILL_MASK             ((uint32)(Clk25KHz_Gen_1BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_PWM_STOP_KILL_SHIFT))
#define Clk25KHz_Gen_PRESCALER_MASK                 ((uint32)(Clk25KHz_Gen_8BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_PRESCALER_SHIFT))
#define Clk25KHz_Gen_UPDOWN_MASK                    ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_UPDOWN_SHIFT))
#define Clk25KHz_Gen_ONESHOT_MASK                   ((uint32)(Clk25KHz_Gen_1BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_ONESHOT_SHIFT))
#define Clk25KHz_Gen_QUAD_MODE_MASK                 ((uint32)(Clk25KHz_Gen_3BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_QUAD_MODE_SHIFT))
#define Clk25KHz_Gen_INV_OUT_MASK                   ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_INV_OUT_SHIFT))
#define Clk25KHz_Gen_MODE_MASK                      ((uint32)(Clk25KHz_Gen_3BIT_MASK        <<  \
                                                                            Clk25KHz_Gen_MODE_SHIFT))

/* Shift constants for trigger control register 1 */
#define Clk25KHz_Gen_CAPTURE_SHIFT                  (0u)
#define Clk25KHz_Gen_COUNT_SHIFT                    (2u)
#define Clk25KHz_Gen_RELOAD_SHIFT                   (4u)
#define Clk25KHz_Gen_STOP_SHIFT                     (6u)
#define Clk25KHz_Gen_START_SHIFT                    (8u)

/* Mask constants for trigger control register 1 */
#define Clk25KHz_Gen_CAPTURE_MASK                   ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                  Clk25KHz_Gen_CAPTURE_SHIFT))
#define Clk25KHz_Gen_COUNT_MASK                     ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                  Clk25KHz_Gen_COUNT_SHIFT))
#define Clk25KHz_Gen_RELOAD_MASK                    ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                  Clk25KHz_Gen_RELOAD_SHIFT))
#define Clk25KHz_Gen_STOP_MASK                      ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                  Clk25KHz_Gen_STOP_SHIFT))
#define Clk25KHz_Gen_START_MASK                     ((uint32)(Clk25KHz_Gen_2BIT_MASK        <<  \
                                                                  Clk25KHz_Gen_START_SHIFT))

/* MASK */
#define Clk25KHz_Gen_1BIT_MASK                      ((uint32)0x01u)
#define Clk25KHz_Gen_2BIT_MASK                      ((uint32)0x03u)
#define Clk25KHz_Gen_3BIT_MASK                      ((uint32)0x07u)
#define Clk25KHz_Gen_6BIT_MASK                      ((uint32)0x3Fu)
#define Clk25KHz_Gen_8BIT_MASK                      ((uint32)0xFFu)
#define Clk25KHz_Gen_16BIT_MASK                     ((uint32)0xFFFFu)

/* Shift constant for status register */
#define Clk25KHz_Gen_RUNNING_STATUS_SHIFT           (30u)


/***************************************
*    Initial Constants
***************************************/

#define Clk25KHz_Gen_CTRL_QUAD_BASE_CONFIG                                                          \
        (((uint32)(Clk25KHz_Gen_QUAD_ENCODING_MODES     << Clk25KHz_Gen_QUAD_MODE_SHIFT))       |\
         ((uint32)(Clk25KHz_Gen_CONFIG                  << Clk25KHz_Gen_MODE_SHIFT)))

#define Clk25KHz_Gen_CTRL_PWM_BASE_CONFIG                                                           \
        (((uint32)(Clk25KHz_Gen_PWM_STOP_EVENT          << Clk25KHz_Gen_PWM_STOP_KILL_SHIFT))   |\
         ((uint32)(Clk25KHz_Gen_PWM_OUT_INVERT          << Clk25KHz_Gen_INV_OUT_SHIFT))         |\
         ((uint32)(Clk25KHz_Gen_PWM_OUT_N_INVERT        << Clk25KHz_Gen_INV_COMPL_OUT_SHIFT))   |\
         ((uint32)(Clk25KHz_Gen_PWM_MODE                << Clk25KHz_Gen_MODE_SHIFT)))

#define Clk25KHz_Gen_CTRL_PWM_RUN_MODE                                                              \
            ((uint32)(Clk25KHz_Gen_PWM_RUN_MODE         << Clk25KHz_Gen_ONESHOT_SHIFT))
            
#define Clk25KHz_Gen_CTRL_PWM_ALIGN                                                                 \
            ((uint32)(Clk25KHz_Gen_PWM_ALIGN            << Clk25KHz_Gen_UPDOWN_SHIFT))

#define Clk25KHz_Gen_CTRL_PWM_KILL_EVENT                                                            \
             ((uint32)(Clk25KHz_Gen_PWM_KILL_EVENT      << Clk25KHz_Gen_PWM_SYNC_KILL_SHIFT))

#define Clk25KHz_Gen_CTRL_PWM_DEAD_TIME_CYCLE                                                       \
            ((uint32)(Clk25KHz_Gen_PWM_DEAD_TIME_CYCLE  << Clk25KHz_Gen_PRESCALER_SHIFT))

#define Clk25KHz_Gen_CTRL_PWM_PRESCALER                                                             \
            ((uint32)(Clk25KHz_Gen_PWM_PRESCALER        << Clk25KHz_Gen_PRESCALER_SHIFT))

#define Clk25KHz_Gen_CTRL_TIMER_BASE_CONFIG                                                         \
        (((uint32)(Clk25KHz_Gen_TC_PRESCALER            << Clk25KHz_Gen_PRESCALER_SHIFT))       |\
         ((uint32)(Clk25KHz_Gen_TC_COUNTER_MODE         << Clk25KHz_Gen_UPDOWN_SHIFT))          |\
         ((uint32)(Clk25KHz_Gen_TC_RUN_MODE             << Clk25KHz_Gen_ONESHOT_SHIFT))         |\
         ((uint32)(Clk25KHz_Gen_TC_COMP_CAP_MODE        << Clk25KHz_Gen_MODE_SHIFT)))
        
#define Clk25KHz_Gen_QUAD_SIGNALS_MODES                                                             \
        (((uint32)(Clk25KHz_Gen_QUAD_PHIA_SIGNAL_MODE   << Clk25KHz_Gen_COUNT_SHIFT))           |\
         ((uint32)(Clk25KHz_Gen_QUAD_INDEX_SIGNAL_MODE  << Clk25KHz_Gen_RELOAD_SHIFT))          |\
         ((uint32)(Clk25KHz_Gen_QUAD_STOP_SIGNAL_MODE   << Clk25KHz_Gen_STOP_SHIFT))            |\
         ((uint32)(Clk25KHz_Gen_QUAD_PHIB_SIGNAL_MODE   << Clk25KHz_Gen_START_SHIFT)))

#define Clk25KHz_Gen_PWM_SIGNALS_MODES                                                              \
        (((uint32)(Clk25KHz_Gen_PWM_SWITCH_SIGNAL_MODE  << Clk25KHz_Gen_CAPTURE_SHIFT))         |\
         ((uint32)(Clk25KHz_Gen_PWM_COUNT_SIGNAL_MODE   << Clk25KHz_Gen_COUNT_SHIFT))           |\
         ((uint32)(Clk25KHz_Gen_PWM_RELOAD_SIGNAL_MODE  << Clk25KHz_Gen_RELOAD_SHIFT))          |\
         ((uint32)(Clk25KHz_Gen_PWM_STOP_SIGNAL_MODE    << Clk25KHz_Gen_STOP_SHIFT))            |\
         ((uint32)(Clk25KHz_Gen_PWM_START_SIGNAL_MODE   << Clk25KHz_Gen_START_SHIFT)))

#define Clk25KHz_Gen_TIMER_SIGNALS_MODES                                                            \
        (((uint32)(Clk25KHz_Gen_TC_CAPTURE_SIGNAL_MODE  << Clk25KHz_Gen_CAPTURE_SHIFT))         |\
         ((uint32)(Clk25KHz_Gen_TC_COUNT_SIGNAL_MODE    << Clk25KHz_Gen_COUNT_SHIFT))           |\
         ((uint32)(Clk25KHz_Gen_TC_RELOAD_SIGNAL_MODE   << Clk25KHz_Gen_RELOAD_SHIFT))          |\
         ((uint32)(Clk25KHz_Gen_TC_STOP_SIGNAL_MODE     << Clk25KHz_Gen_STOP_SHIFT))            |\
         ((uint32)(Clk25KHz_Gen_TC_START_SIGNAL_MODE    << Clk25KHz_Gen_START_SHIFT)))
        
#define Clk25KHz_Gen_TIMER_UPDOWN_CNT_USED                                                          \
                ((Clk25KHz_Gen__COUNT_UPDOWN0 == Clk25KHz_Gen_TC_COUNTER_MODE)                  ||\
                 (Clk25KHz_Gen__COUNT_UPDOWN1 == Clk25KHz_Gen_TC_COUNTER_MODE))

#define Clk25KHz_Gen_PWM_UPDOWN_CNT_USED                                                            \
                ((Clk25KHz_Gen__CENTER == Clk25KHz_Gen_PWM_ALIGN)                               ||\
                 (Clk25KHz_Gen__ASYMMETRIC == Clk25KHz_Gen_PWM_ALIGN))               
        
#define Clk25KHz_Gen_PWM_PR_INIT_VALUE              (1u)
#define Clk25KHz_Gen_QUAD_PERIOD_INIT_VALUE         (0x8000u)



#endif /* End CY_TCPWM_Clk25KHz_Gen_H */

/* [] END OF FILE */
