/*******************************************************************************
* File Name: Clk25KHz_Gen_PM.c
* Version 2.10
*
* Description:
*  This file contains the setup, control, and status commands to support
*  the component operations in the low power mode.
*
* Note:
*  None
*
********************************************************************************
* Copyright 2013-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "Clk25KHz_Gen.h"

static Clk25KHz_Gen_BACKUP_STRUCT Clk25KHz_Gen_backup;


/*******************************************************************************
* Function Name: Clk25KHz_Gen_SaveConfig
********************************************************************************
*
* Summary:
*  All configuration registers are retention. Nothing to save here.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Clk25KHz_Gen_SaveConfig(void)
{

}


/*******************************************************************************
* Function Name: Clk25KHz_Gen_Sleep
********************************************************************************
*
* Summary:
*  Stops the component operation and saves the user configuration.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Clk25KHz_Gen_Sleep(void)
{
    if(0u != (Clk25KHz_Gen_BLOCK_CONTROL_REG & Clk25KHz_Gen_MASK))
    {
        Clk25KHz_Gen_backup.enableState = 1u;
    }
    else
    {
        Clk25KHz_Gen_backup.enableState = 0u;
    }

    Clk25KHz_Gen_Stop();
    Clk25KHz_Gen_SaveConfig();
}


/*******************************************************************************
* Function Name: Clk25KHz_Gen_RestoreConfig
********************************************************************************
*
* Summary:
*  All configuration registers are retention. Nothing to restore here.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Clk25KHz_Gen_RestoreConfig(void)
{

}


/*******************************************************************************
* Function Name: Clk25KHz_Gen_Wakeup
********************************************************************************
*
* Summary:
*  Restores the user configuration and restores the enable state.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Clk25KHz_Gen_Wakeup(void)
{
    Clk25KHz_Gen_RestoreConfig();

    if(0u != Clk25KHz_Gen_backup.enableState)
    {
        Clk25KHz_Gen_Enable();
    }
}


/* [] END OF FILE */
