#ifndef EM_EEPROM_UTILS_H
#define EM_EEPROM_UTILS_H
    
#include "project.h"
/*Logical Size of Em_EEPROM*/
#define LOGICAL_EEPROM_SIZE     15u
#define LOGICAL_EEPROM_START    0u

/*location of reset counter in Em_EEPROM*/
#define RESET_COUNT_LOCATION    13u
#define RESET_COUNT_SIZE        2u
    
#define NUM_COUNTER             3
#define DEFAULT_PERIOD         99
#define DEFAULT_COMPARE        49
    
#define COUNTER_STOPPED         0
#define COUNTER_RUNNING         1
    
typedef struct pwm_st {
    uint16_t period ;
    uint16_t compare ;
    uint16_t status ;
} pwm_counter_type ;

/* global variables */
/*Return status for EEPROM and UART*/ 
extern cy_en_em_eeprom_status_t eepromReturnValue;
    
extern const uint8_t Em_EEPROM_em_EepromStorage[] ;

extern pwm_counter_type counter[] ;

/* function prototypes */
void print_em_eprom_error(cy_en_em_eeprom_status_t status) ;

cy_en_em_eeprom_status_t init_em_eeprom(void) ;

cy_en_em_eeprom_status_t load_pwm(void) ;

cy_en_em_eeprom_status_t save_pwm(void) ;

int is_eeprom_empty(pwm_counter_type *counter) ;

void init_counter_values(void) ;

#endif /* EM_EEPROM_UTILS_H */
